@ Asm 16Bits Blur . by Orion_ [2004]
@
@ Reference it from C by using:
@  extern void DoBlur (unsigned char *src, unsigned char *dest);
@
@ Entry:
@  r0 = src, r1 = dest

@ sans Blur      : 5.6s
@ avec Blur (old): 9.8s
@ sans Blur (new): 9.6s

	.ALIGN
	.GLOBAL DoHardBlur
	.TYPE   DoHardBlur, function

DoHardBlur:
	stmfd	r13!,{r4,r5,r6,r7,r8,r9}
	mov	r2,#37
	mov	r12,r2,lsl #11
	add	r12,r12,#544		@ r12=(37*2048)+544=318*240=76320 why this weird operation ? because #76320 dont work

					@ r0=source 1 (-240)
	mov	r2,r0			@ r2=source 2 (-1)
	mov	r9,#239
	add	r2,r2,r9,lsl #1		@ cos of strange asm bug here :|

	mov	r3,r0			@ r3=source 3 (+1)
	mov	r9,#241
	add	r3,r3,r9,lsl #1		@ cos of strange asm bug here :|

	mov	r4,r0			@ r4=source 4 (+240)
	add	r4,r4,#960

	add	r1,r1,#480		@ next destination line

BlurLoop:
	mov	r6,#0			@ Clear just to be sure
	mov	r7,#0
	mov	r8,#0

	ldrh	r5,[r0],#2		@ Load the 16Bits color 1 *(p++)
	mov	r6,r5,lsr #1		@ B
	mov	r7,r5,lsr #6		@ G
	mov	r8,r5,lsr #11		@ R
	and	r6,r6,#31		@ isole les couleurs
	and	r7,r7,#31
	and	r8,r8,#31

	ldrh	r5,[r2],#2		@ Load the 16Bits color 2 *(p++)
	mov	r5,r5,lsr #1
	and	r5,r5,#31
	add	r6,r6,r5		@ +B
	mov	r5,r5,lsr #5
	and	r5,r5,#31
	add	r7,r7,r5		@ +G
	mov	r5,r5,lsr #5
	and	r5,r5,#31
	add	r8,r8,r5		@ +R

	ldrh	r5,[r3],#2		@ Load the 16Bits color 3 *(p++)
	mov	r5,r5,lsr #1
	and	r5,r5,#31
	add	r6,r6,r5		@ +B
	mov	r5,r5,lsr #5
	and	r5,r5,#31
	add	r7,r7,r5		@ +G
	mov	r5,r5,lsr #5
	and	r5,r5,#31
	add	r8,r8,r5		@ +R

	ldrh	r5,[r4],#2		@ Load the 16Bits color 4 *(p++)
	mov	r5,r5,lsr #1
	and	r5,r5,#31
	add	r6,r6,r5		@ +B
	mov	r5,r5,lsr #5
	and	r5,r5,#31
	add	r7,r7,r5		@ +G
	mov	r5,r5,lsr #5
	and	r5,r5,#31
	add	r8,r8,r5		@ +R

	mov	r6,r6,lsr #1		@ Blur+HighLight
	mov	r7,r7,lsr #1
	mov	r8,r8,lsr #1
	cmp	r6,#31
	movhi	r6,#31
	cmp	r7,#31
	movhi	r7,#31
	cmp	r8,#31
	movhi	r8,#31
	and	r6,r6,#31		@ isole les couleurs
	and	r7,r7,#31
	and	r8,r8,#31

	mov	r5,#0			@ Clear just to be sure
	mov	r5,r8,lsl #11		@ recompose the final color
	add	r5,r5,r7,lsl #6
	add	r5,r5,r6,lsl #1

	strh	r5,[r1],#2		@ put the final color

	subs	r12,r12,#1
	bne	BlurLoop

	ldmfd	r13!,{r4,r5,r6,r7,r8,r9}
	bx	lr
.fend1:
	.SIZE DoHardBlur, .fend1-DoHardBlur
