#ifndef __gp32_types_h__
#define __gp32_types_h__

typedef unsigned char uint8;
typedef signed char int8;

typedef unsigned short uint16;
typedef signed short int16;

typedef unsigned int uint32;
typedef signed int int32;

typedef unsigned long long uint64;
typedef signed long long int64;

/*__asm { smull r0,r1,a,b; \
	mov r0,r0,lsr 16; orr r0,r0,r1,lsl 16;mov res,r0;} }
*/

#define SMULT1616(res,a,b) {\
asm volatile("smull  %0, r10, %1, %2\n"\
             "mov %0,%0,lsr #16\n"\
             "orr %0,%0,r10,lsl #16\n"\
               : "=r"(res) \
               : "r"(a),"r"(b) \
	       : "cc","r10");}
	       
#define SADDMULT1616(res,a,b,c,d) {\
/*		res=((int64)a*(int64)b+(int64)c*(int64)d)>>16; }*/ \
asm volatile ("smull %0,r10,%1,%2\n"\
	      "smlal %0,r10,%3,%4\n"\
	      "mov   %0,%0,lsr #16\n"\
	      "orr   %0,%0,r10,lsl #16\n"\
	        : "=&r"(res) \
	        : "r" (a),"r"(b),"r"(c),"r"(d) \
	        : "cc","r10");}
	       

#endif
